/* Author: Tobi Vollebregt */

/*  Marsworm -- A small game written for the TINS Is Not SpeedHack 2003
 *  Copyright (C) 2003  Tobi Vollebregt
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  See `License.txt', which contains a verbatim copy of the
 *  GNU General Public License, for details.
 *
 *  Please send your reaction to: tobivollebregt@hotmail.com
 */

#ifndef _tj_AALINE_H_
#define _tj_AALINE_H_

#ifdef __cplusplus
extern "C" {
#endif

/* These antialiased line drawers do _not_ support clipping.
    The 8 bit version needs the colors 0 to 63 of
        the palette to be a smooth gradient.
    aa_line() calls the right low level function,
        based on the colordepth of the bitmap.
*/
void _linear_aa_line_8 (BITMAP *b, int x1, int y1, int x2, int y2, int color);
void _linear_aa_line_15(BITMAP *b, int x1, int y1, int x2, int y2, int color);
void _linear_aa_line_16(BITMAP *b, int x1, int y1, int x2, int y2, int color);
void _linear_aa_line_24(BITMAP *b, int x1, int y1, int x2, int y2, int color);
void _linear_aa_line_32(BITMAP *b, int x1, int y1, int x2, int y2, int color);
void aa_line(BITMAP *b, int x1, int y1, int x2, int y2, int color);

#ifdef __cplusplus
}   // end of extern "C"
#endif

#endif /* #ifndef _tj_AALINE_H_ */
