/* Author: Tobi Vollebregt */

/*  Marsworm -- A small game written for the TINS Is Not SpeedHack 2003
 *  Copyright (C) 2003  Tobi Vollebregt
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  See `License.txt', which contains a verbatim copy of the
 *  GNU General Public License, for details.
 *
 *  Please send your reaction to: tobivollebregt@hotmail.com
 */

#include <allegro.h>
//#include <allegro/internal/aintern.h>

//#define BLEND(bpp, r, g, b)   _blender_trans##bpp(makecol##bpp(r, g, b), y, n)

//unsigned long _blender_trans15(unsigned long, unsigned long, unsigned long);
//unsigned long _blender_trans16(unsigned long, unsigned long, unsigned long);
//unsigned long _blender_trans24(unsigned long, unsigned long, unsigned long);

#ifdef ALLEGRO_COLOR16
static unsigned long add2_blender15(unsigned long x, unsigned long y, unsigned long n)
{
    int r = getr15(x) + getr15(y);
    int g = getg15(x) + getg15(y);
    int b = getb15(x) + getb15(y);
    return makecol15(MIN(r, 255), MIN(g, 255), MIN(b, 255));
}

static unsigned long add2_blender16(unsigned long x, unsigned long y, unsigned long n)
{
    int r = getr16(x) + getr16(y);
    int g = getg16(x) + getg16(y);
    int b = getb16(x) + getb16(y);
    return makecol16(MIN(r, 255), MIN(g, 255), MIN(b, 255));
}
// in tankzone is was called "max" blender
#define MAXB15 add2_blender15
#define MAXB16 add2_blender16
#else
#define MAXB15 NULL
#define MAXB16 NULL
#endif /* #ifdef ALLEGRO_COLOR_16 */

#if (defined ALLEGRO_COLOR24) || (defined ALLEGRO_COLOR32)
/* 24 bit maximum color blender */
static unsigned long add2_blender24(unsigned long x, unsigned long y, unsigned long n)
{
    int r = getr24(x) + getr24(y);
    int g = getg24(x) + getg24(y);
    int b = getb24(x) + getb24(y);
    return makecol24(MIN(r, 255), MIN(g, 255), MIN(b, 255));
}
#define MAXB24 add2_blender24
#else
#define MAXB24 NULL
#endif /* #if (defined ALLEGRO_COLOR24) || (defined ALLEGRO_COLOR32) */

void set_my_add_blender(int r,int g,int b,int a)
{
    set_blender_mode(MAXB15,MAXB16,MAXB24,r,g,b,a);
}
