/* Author: Tobi Vollebregt */

/*  Marsworm -- A small game written for the TINS Is Not SpeedHack 2003
 *  Copyright (C) 2003  Tobi Vollebregt
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  See `License.txt', which contains a verbatim copy of the
 *  GNU General Public License, for details.
 *
 *  Please send your reaction to: tobivollebregt@hotmail.com
 */

#ifndef __tjv_monster_h__
#define __tjv_monster_h__

#include "vector.h"
#define MAX_ENEMIES 1
#define MAX_FOOD 10
#define TRAIL_LENGTH 3000

class Moon;

class Monsters
{
 public:
    Monsters() {}
    ~Monsters();

    void initialize();

    int update(const Vector& player, bool change);
    void draw(BITMAP* bmp, MATRIX_f* matrix, Moon* moon);

    int getScore() const { return score; }

 private:

    BITMAP* blob[32];
    BITMAP* eye;
    //bool hit;
    //Vector blood;

    struct Enemy // since I changed the goal of the game entirely
    {           // this is now just the player, and there are no enemies
        int length;
        Vector trail[TRAIL_LENGTH];
    };

    Enemy enemies[MAX_ENEMIES];

    struct Food
    {
        int text_index;
        Vector pos;
        BITMAP* food_bmp;
    };
    Food food[MAX_FOOD];
    int score;
    Vector dir0;
};

#endif // !defined(__tjv_monster_h__)
