/* Author: Tobi Vollebregt */

/*  Marsworm -- A small game written for the TINS Is Not SpeedHack 2003
 *  Copyright (C) 2003  Tobi Vollebregt
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  See `License.txt', which contains a verbatim copy of the
 *  GNU General Public License, for details.
 *
 *  Please send your reaction to: tobivollebregt@hotmail.com
 */

#ifndef __tjv_particle_h__
#define __tjv_particle_h__

#include "vector.h"

// A particle system class
// not quite usefull actually, only the red dots are done by this class

#define NUM_PARTS 10

class Particle
{
 public:

    Particle();

    void update();
    void draw(BITMAP* bmp, MATRIX_f* matrix);

    void kaboom(float radius, int n, const Vector& pos, const Vector& speed, float r1, float r2, int color, int alpha, int alphaspeed);

    enum { PIXEL, SQUARE2, SQUARE3, CROSS, CIRCLE };

 private:

    struct Part
    {
        Vector pos, speed;
        float radius;
        int color, alpha, alphaspeed;
    };

    Part parts[NUM_PARTS];
};

#endif // !defined(__tjv_particle_h__)
